#ifndef PLUGIN1_H
#define PLUGIN1_H

class AbstractPlugin;

class Plugin1 {
public:
    Plugin1(AbstractPlugin *plugin)
        :m_plugin(plugin)
    {
    }

    void doSmth()
    {
        if (!QMetaObject::invokeMethod(m_plugin, "doSmth", Qt::DirectConnection))
            qWarning("not called: %s", "Plugin1::doSmth()");
    }

    QString foo(QString arg, Struct1 s1)
    {
        QString retVal;
        QMetaObject::invokeMethod(m_plugin, "foo",
            Qt::DirectConnection,
            Q_RETURN_ARG(QString, retVal),
            Q_ARG(QString, arg),
            Q_ARG(Struct1, s1));
        return retVal;
    }

private:
    AbstractPlugin *m_plugin;
};

#endif
